/* accounts.c generated by valac 0.12.0, the Vala compiler
 * generated from accounts.vala, do not modify */

/* accounts.vala
 *
 * Copyright (C) 2009-2010  troorl
 * Copyright (C) 2010 Kushal Das <kushal@fedoraproject.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	troorl <troorl@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdio.h>
#include <libxml/parser.h>
#include <libxml/tree.h>


#define AUTH_TYPE_ACCOUNT (auth_account_get_type ())
#define AUTH_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUTH_TYPE_ACCOUNT, AuthAccount))
#define AUTH_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUTH_TYPE_ACCOUNT, AuthAccountClass))
#define AUTH_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUTH_TYPE_ACCOUNT))
#define AUTH_IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUTH_TYPE_ACCOUNT))
#define AUTH_ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUTH_TYPE_ACCOUNT, AuthAccountClass))

typedef struct _AuthAccount AuthAccount;
typedef struct _AuthAccountClass AuthAccountClass;
typedef struct _AuthAccountPrivate AuthAccountPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define AUTH_TYPE_ACCOUNTS (auth_accounts_get_type ())
#define AUTH_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUTH_TYPE_ACCOUNTS, AuthAccounts))
#define AUTH_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUTH_TYPE_ACCOUNTS, AuthAccountsClass))
#define AUTH_IS_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUTH_TYPE_ACCOUNTS))
#define AUTH_IS_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUTH_TYPE_ACCOUNTS))
#define AUTH_ACCOUNTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUTH_TYPE_ACCOUNTS, AuthAccountsClass))

typedef struct _AuthAccounts AuthAccounts;
typedef struct _AuthAccountsClass AuthAccountsClass;
typedef struct _AuthAccountsPrivate AuthAccountsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

struct _AuthAccount {
	GObject parent_instance;
	AuthAccountPrivate * priv;
};

struct _AuthAccountClass {
	GObjectClass parent_class;
};

struct _AuthAccountPrivate {
	gchar* _login;
	gchar* _password;
	gchar* _service;
	gchar* _proxy;
	gboolean _active;
};

struct _AuthAccounts {
	GObject parent_instance;
	AuthAccountsPrivate * priv;
	gboolean is_new;
};

struct _AuthAccountsClass {
	GObjectClass parent_class;
};

struct _AuthAccountsPrivate {
	GeeArrayList* acc_lst;
	gchar* acc_file_path;
};


static gpointer auth_account_parent_class = NULL;
static gpointer auth_accounts_parent_class = NULL;

GType auth_account_get_type (void) G_GNUC_CONST;
#define AUTH_ACCOUNT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), AUTH_TYPE_ACCOUNT, AuthAccountPrivate))
enum  {
	AUTH_ACCOUNT_DUMMY_PROPERTY,
	AUTH_ACCOUNT_LOGIN,
	AUTH_ACCOUNT_PASSWORD,
	AUTH_ACCOUNT_SERVICE,
	AUTH_ACCOUNT_PROXY,
	AUTH_ACCOUNT_ACTIVE
};
AuthAccount* auth_account_new_with_data (const gchar* __login, const gchar* __password, const gchar* __service, gboolean __active);
AuthAccount* auth_account_construct_with_data (GType object_type, const gchar* __login, const gchar* __password, const gchar* __service, gboolean __active);
AuthAccount* auth_account_new (void);
AuthAccount* auth_account_construct (GType object_type);
const gchar* auth_account_get_login (AuthAccount* self);
void auth_account_set_login (AuthAccount* self, const gchar* value);
const gchar* auth_account_get_password (AuthAccount* self);
void auth_account_set_password (AuthAccount* self, const gchar* value);
const gchar* auth_account_get_service (AuthAccount* self);
void auth_account_set_service (AuthAccount* self, const gchar* value);
const gchar* auth_account_get_proxy (AuthAccount* self);
void auth_account_set_proxy (AuthAccount* self, const gchar* value);
gboolean auth_account_get_active (AuthAccount* self);
void auth_account_set_active (AuthAccount* self, gboolean value);
static void auth_account_finalize (GObject* obj);
static void _vala_auth_account_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_auth_account_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType auth_accounts_get_type (void) G_GNUC_CONST;
#define AUTH_ACCOUNTS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), AUTH_TYPE_ACCOUNTS, AuthAccountsPrivate))
enum  {
	AUTH_ACCOUNTS_DUMMY_PROPERTY,
	AUTH_ACCOUNTS_ACCOUNTS
};
AuthAccounts* auth_accounts_new (void);
AuthAccounts* auth_accounts_construct (GType object_type);
static void auth_accounts_load (AuthAccounts* self);
static void auth_accounts_parse (AuthAccounts* self, const gchar* data);
void auth_accounts_write (AuthAccounts* self);
AuthAccount* auth_accounts_get_current_account (AuthAccounts* self);
void auth_accounts_add_account (AuthAccounts* self, AuthAccount* acc);
void auth_accounts_delete_account (AuthAccounts* self, const gchar* hash);
AuthAccount* auth_accounts_get_by_hash (AuthAccounts* self, const gchar* hash);
void auth_accounts_set_active_account (AuthAccounts* self, const gchar* hash);
void auth_accounts_change_account (AuthAccounts* self, gint index, AuthAccount* acc);
GeeArrayList* auth_accounts_get_accounts (AuthAccounts* self);
static void auth_accounts_finalize (GObject* obj);
static void _vala_auth_accounts_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


AuthAccount* auth_account_construct_with_data (GType object_type, const gchar* __login, const gchar* __password, const gchar* __service, gboolean __active) {
	AuthAccount * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (__login != NULL, NULL);
	g_return_val_if_fail (__password != NULL, NULL);
	g_return_val_if_fail (__service != NULL, NULL);
	self = (AuthAccount*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (__login);
	_g_free0 (self->priv->_login);
	self->priv->_login = _tmp0_;
	_tmp1_ = g_strdup (__password);
	_g_free0 (self->priv->_password);
	self->priv->_password = _tmp1_;
	_tmp2_ = g_strdup (__service);
	_g_free0 (self->priv->_service);
	self->priv->_service = _tmp2_;
	self->priv->_active = __active;
	return self;
}


AuthAccount* auth_account_new_with_data (const gchar* __login, const gchar* __password, const gchar* __service, gboolean __active) {
	return auth_account_construct_with_data (AUTH_TYPE_ACCOUNT, __login, __password, __service, __active);
}


AuthAccount* auth_account_construct (GType object_type) {
	AuthAccount * self = NULL;
	self = (AuthAccount*) g_object_new (object_type, NULL);
	return self;
}


AuthAccount* auth_account_new (void) {
	return auth_account_construct (AUTH_TYPE_ACCOUNT);
}


const gchar* auth_account_get_login (AuthAccount* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_login;
	return result;
}


void auth_account_set_login (AuthAccount* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_login);
	self->priv->_login = _tmp0_;
	g_object_notify ((GObject *) self, "login");
}


const gchar* auth_account_get_password (AuthAccount* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_password;
	return result;
}


void auth_account_set_password (AuthAccount* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_password);
	self->priv->_password = _tmp0_;
	g_object_notify ((GObject *) self, "password");
}


const gchar* auth_account_get_service (AuthAccount* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_service;
	return result;
}


void auth_account_set_service (AuthAccount* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_service);
	self->priv->_service = _tmp0_;
	g_object_notify ((GObject *) self, "service");
}


const gchar* auth_account_get_proxy (AuthAccount* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_proxy;
	return result;
}


void auth_account_set_proxy (AuthAccount* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_proxy);
	self->priv->_proxy = _tmp0_;
	g_object_notify ((GObject *) self, "proxy");
}


gboolean auth_account_get_active (AuthAccount* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_active;
	return result;
}


void auth_account_set_active (AuthAccount* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_active = value;
	g_object_notify ((GObject *) self, "active");
}


static void auth_account_class_init (AuthAccountClass * klass) {
	auth_account_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AuthAccountPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_auth_account_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_auth_account_set_property;
	G_OBJECT_CLASS (klass)->finalize = auth_account_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUTH_ACCOUNT_LOGIN, g_param_spec_string ("login", "login", "login", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUTH_ACCOUNT_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUTH_ACCOUNT_SERVICE, g_param_spec_string ("service", "service", "service", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUTH_ACCOUNT_PROXY, g_param_spec_string ("proxy", "proxy", "proxy", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUTH_ACCOUNT_ACTIVE, g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void auth_account_instance_init (AuthAccount * self) {
	gchar* _tmp0_;
	self->priv = AUTH_ACCOUNT_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("");
	self->priv->_proxy = _tmp0_;
}


static void auth_account_finalize (GObject* obj) {
	AuthAccount * self;
	self = AUTH_ACCOUNT (obj);
	_g_free0 (self->priv->_login);
	_g_free0 (self->priv->_password);
	_g_free0 (self->priv->_service);
	_g_free0 (self->priv->_proxy);
	G_OBJECT_CLASS (auth_account_parent_class)->finalize (obj);
}


GType auth_account_get_type (void) {
	static volatile gsize auth_account_type_id__volatile = 0;
	if (g_once_init_enter (&auth_account_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AuthAccountClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) auth_account_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AuthAccount), 0, (GInstanceInitFunc) auth_account_instance_init, NULL };
		GType auth_account_type_id;
		auth_account_type_id = g_type_register_static (G_TYPE_OBJECT, "AuthAccount", &g_define_type_info, 0);
		g_once_init_leave (&auth_account_type_id__volatile, auth_account_type_id);
	}
	return auth_account_type_id__volatile;
}


static void _vala_auth_account_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AuthAccount * self;
	self = AUTH_ACCOUNT (object);
	switch (property_id) {
		case AUTH_ACCOUNT_LOGIN:
		g_value_set_string (value, auth_account_get_login (self));
		break;
		case AUTH_ACCOUNT_PASSWORD:
		g_value_set_string (value, auth_account_get_password (self));
		break;
		case AUTH_ACCOUNT_SERVICE:
		g_value_set_string (value, auth_account_get_service (self));
		break;
		case AUTH_ACCOUNT_PROXY:
		g_value_set_string (value, auth_account_get_proxy (self));
		break;
		case AUTH_ACCOUNT_ACTIVE:
		g_value_set_boolean (value, auth_account_get_active (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_auth_account_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AuthAccount * self;
	self = AUTH_ACCOUNT (object);
	switch (property_id) {
		case AUTH_ACCOUNT_LOGIN:
		auth_account_set_login (self, g_value_get_string (value));
		break;
		case AUTH_ACCOUNT_PASSWORD:
		auth_account_set_password (self, g_value_get_string (value));
		break;
		case AUTH_ACCOUNT_SERVICE:
		auth_account_set_service (self, g_value_get_string (value));
		break;
		case AUTH_ACCOUNT_PROXY:
		auth_account_set_proxy (self, g_value_get_string (value));
		break;
		case AUTH_ACCOUNT_ACTIVE:
		auth_account_set_active (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


AuthAccounts* auth_accounts_construct (GType object_type) {
	AuthAccounts * self = NULL;
	GeeArrayList* _tmp0_ = NULL;
	self = (AuthAccounts*) g_object_new (object_type, NULL);
	_tmp0_ = gee_array_list_new (AUTH_TYPE_ACCOUNT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	_g_object_unref0 (self->priv->acc_lst);
	self->priv->acc_lst = _tmp0_;
	auth_accounts_load (self);
	return self;
}


AuthAccounts* auth_accounts_new (void) {
	return auth_accounts_construct (AUTH_TYPE_ACCOUNTS);
}


static void auth_accounts_load (AuthAccounts* self) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* pino_dir;
	GFile* _tmp2_ = NULL;
	GFile* dir;
	gboolean _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_ = NULL;
	GFile* acc_file;
	gboolean _tmp6_;
	gchar* content = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_strconcat (_tmp0_, "/lekhonee-gnome", NULL);
	pino_dir = _tmp1_;
	_tmp2_ = g_file_new_for_path (pino_dir);
	dir = _tmp2_;
	_tmp3_ = g_file_query_exists (dir, NULL);
	if (!_tmp3_) {
		g_file_make_directory (dir, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (dir);
			_g_free0 (pino_dir);
			goto __catch0_g_error;
		}
	}
	_g_object_unref0 (dir);
	dir = NULL;
	_tmp4_ = g_strconcat (pino_dir, "/accounts.xml", NULL);
	_g_free0 (self->priv->acc_file_path);
	self->priv->acc_file_path = _tmp4_;
	_tmp5_ = g_file_new_for_path (self->priv->acc_file_path);
	acc_file = _tmp5_;
	_tmp6_ = g_file_query_exists (acc_file, NULL);
	if (!_tmp6_) {
		self->is_new = TRUE;
		_g_object_unref0 (acc_file);
		_g_object_unref0 (dir);
		_g_free0 (pino_dir);
		return;
	}
	{
		GFileInputStream* _tmp7_ = NULL;
		GFileInputStream* _tmp8_;
		GFileInputStream* _tmp9_;
		GDataInputStream* _tmp10_ = NULL;
		GDataInputStream* _tmp11_;
		GDataInputStream* stream;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		_tmp7_ = g_file_read (acc_file, NULL, &_inner_error_);
		_tmp8_ = _tmp7_;
		if (_inner_error_ != NULL) {
			_g_free0 (content);
			_g_object_unref0 (acc_file);
			_g_object_unref0 (dir);
			_g_free0 (pino_dir);
			goto __catch0_g_error;
		}
		_tmp9_ = _tmp8_;
		_tmp10_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp9_);
		stream = _tmp11_;
		_tmp12_ = g_data_input_stream_read_until (stream, "", NULL, NULL, &_inner_error_);
		_tmp13_ = _tmp12_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (stream);
			_g_free0 (content);
			_g_object_unref0 (acc_file);
			_g_object_unref0 (dir);
			_g_free0 (pino_dir);
			goto __catch0_g_error;
		}
		_g_free0 (content);
		content = _tmp13_;
		_g_object_unref0 (stream);
	}
	auth_accounts_parse (self, content);
	_g_free0 (content);
	_g_object_unref0 (acc_file);
	_g_object_unref0 (dir);
	_g_free0 (pino_dir);
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		fprintf (stderr, "Error: %s\n", e->message);
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gboolean bool_parse (const gchar* str) {
	gboolean result = FALSE;
	g_return_val_if_fail (str != NULL, FALSE);
	if (g_strcmp0 (str, "true") == 0) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


static void auth_accounts_parse (AuthAccounts* self, const gchar* data) {
	gint _tmp0_;
	xmlDoc* _tmp1_ = NULL;
	xmlDoc* xmlDoc;
	xmlNode* _tmp2_ = NULL;
	xmlNode* rootNode;
	g_return_if_fail (self != NULL);
	g_return_if_fail (data != NULL);
	_tmp0_ = strlen (data);
	_tmp1_ = xmlParseMemory (data, (gint) _tmp0_);
	xmlDoc = _tmp1_;
	_tmp2_ = xmlDocGetRootElement (xmlDoc);
	rootNode = _tmp2_;
	{
		xmlNode* iter;
		iter = rootNode->children;
		{
			gboolean _tmp3_;
			_tmp3_ = TRUE;
			while (TRUE) {
				if (!_tmp3_) {
					iter = iter->next;
				}
				_tmp3_ = FALSE;
				if (!(iter != NULL)) {
					break;
				}
				if (iter->type != XML_ELEMENT_NODE) {
					continue;
				}
				if (g_strcmp0 (iter->name, "account") == 0) {
					if (iter->children != NULL) {
						AuthAccount* _tmp4_ = NULL;
						AuthAccount* acc;
						xmlNode* iter_in = NULL;
						_tmp4_ = auth_account_new ();
						acc = _tmp4_;
						{
							gboolean _tmp5_;
							iter_in = iter->children;
							_tmp5_ = TRUE;
							while (TRUE) {
								gint _tmp6_;
								if (!_tmp5_) {
									iter_in = iter_in->next;
								}
								_tmp5_ = FALSE;
								if (!(iter_in != NULL)) {
									break;
								}
								_tmp6_ = xmlNodeIsText (iter_in);
								if (_tmp6_ != 1) {
									const gchar* _tmp7_;
									GQuark _tmp8_;
									static GQuark _tmp8__label0 = 0;
									static GQuark _tmp8__label1 = 0;
									static GQuark _tmp8__label2 = 0;
									static GQuark _tmp8__label3 = 0;
									static GQuark _tmp8__label4 = 0;
									_tmp7_ = iter_in->name;
									_tmp8_ = (NULL == _tmp7_) ? 0 : g_quark_from_string (_tmp7_);
									if (_tmp8_ == ((0 != _tmp8__label0) ? _tmp8__label0 : (_tmp8__label0 = g_quark_from_static_string ("login")))) {
										switch (0) {
											default:
											{
												gchar* _tmp9_ = NULL;
												gchar* _tmp10_;
												_tmp9_ = xmlNodeGetContent (iter_in);
												_tmp10_ = _tmp9_;
												auth_account_set_login (acc, _tmp10_);
												_g_free0 (_tmp10_);
												break;
											}
										}
									} else if (_tmp8_ == ((0 != _tmp8__label1) ? _tmp8__label1 : (_tmp8__label1 = g_quark_from_static_string ("password")))) {
										switch (0) {
											default:
											{
												gchar* _tmp11_ = NULL;
												gchar* _tmp12_;
												_tmp11_ = xmlNodeGetContent (iter_in);
												_tmp12_ = _tmp11_;
												auth_account_set_password (acc, _tmp12_);
												_g_free0 (_tmp12_);
												break;
											}
										}
									} else if (_tmp8_ == ((0 != _tmp8__label2) ? _tmp8__label2 : (_tmp8__label2 = g_quark_from_static_string ("service")))) {
										switch (0) {
											default:
											{
												gchar* _tmp13_ = NULL;
												gchar* _tmp14_;
												_tmp13_ = xmlNodeGetContent (iter_in);
												_tmp14_ = _tmp13_;
												auth_account_set_service (acc, _tmp14_);
												_g_free0 (_tmp14_);
												break;
											}
										}
									} else if (_tmp8_ == ((0 != _tmp8__label3) ? _tmp8__label3 : (_tmp8__label3 = g_quark_from_static_string ("proxy")))) {
										switch (0) {
											default:
											{
												gchar* _tmp15_ = NULL;
												gchar* _tmp16_;
												_tmp15_ = xmlNodeGetContent (iter_in);
												_tmp16_ = _tmp15_;
												auth_account_set_proxy (acc, _tmp16_);
												_g_free0 (_tmp16_);
												break;
											}
										}
									} else if (_tmp8_ == ((0 != _tmp8__label4) ? _tmp8__label4 : (_tmp8__label4 = g_quark_from_static_string ("active")))) {
										switch (0) {
											default:
											{
												gchar* _tmp17_ = NULL;
												gchar* _tmp18_;
												gboolean _tmp19_;
												_tmp17_ = xmlNodeGetContent (iter_in);
												_tmp18_ = _tmp17_;
												_tmp19_ = bool_parse (_tmp18_);
												auth_account_set_active (acc, _tmp19_);
												_g_free0 (_tmp18_);
												break;
											}
										}
									}
								}
							}
						}
						xmlFreeNode (iter_in);
						gee_abstract_collection_add ((GeeAbstractCollection*) self->priv->acc_lst, acc);
						_g_object_unref0 (acc);
					}
				}
			}
		}
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


void auth_accounts_write (AuthAccounts* self) {
	xmlDoc* _tmp0_ = NULL;
	xmlDoc* xmldoc;
	xmlNs* _tmp1_ = NULL;
	xmlNs* ns;
	xmlNode* _tmp2_ = NULL;
	xmlNode* root;
	FILE* _tmp14_ = NULL;
	FILE* stream;
	g_return_if_fail (self != NULL);
	_tmp0_ = xmlNewDoc ("1.0");
	xmldoc = _tmp0_;
	_tmp1_ = xmlNewNs (NULL, NULL, NULL);
	ns = _tmp1_;
	ns->type = XML_ELEMENT_NODE;
	_tmp2_ = xmlNewNode (ns, "accounts");
	root = _tmp2_;
	xmlDocSetRootElement (xmldoc, root);
	xmlNodeAddContent (root, "\n");
	{
		GeeArrayList* _tmp3_;
		GeeArrayList* _acc_list;
		gint _tmp4_;
		gint _acc_size;
		gint _acc_index;
		_tmp3_ = _g_object_ref0 (self->priv->acc_lst);
		_acc_list = _tmp3_;
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _acc_list);
		_acc_size = _tmp4_;
		_acc_index = -1;
		while (TRUE) {
			gpointer _tmp5_ = NULL;
			AuthAccount* acc;
			xmlNode* iter = NULL;
			xmlNode* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			gboolean _tmp11_;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			_acc_index = _acc_index + 1;
			if (!(_acc_index < _acc_size)) {
				break;
			}
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _acc_list, _acc_index);
			acc = (AuthAccount*) _tmp5_;
			_tmp6_ = xmlNewChild (root, ns, "account", NULL);
			iter = _tmp6_;
			xmlNodeAddContent (iter, "\n\t");
			_tmp7_ = auth_account_get_login (acc);
			xmlNewTextChild (iter, ns, "login", _tmp7_);
			xmlNodeAddContent (iter, "\n\t");
			_tmp8_ = auth_account_get_password (acc);
			xmlNewTextChild (iter, ns, "password", _tmp8_);
			xmlNodeAddContent (iter, "\n\t");
			_tmp9_ = auth_account_get_service (acc);
			xmlNewTextChild (iter, ns, "service", _tmp9_);
			xmlNodeAddContent (iter, "\n\t");
			_tmp10_ = auth_account_get_proxy (acc);
			xmlNewTextChild (iter, ns, "proxy", _tmp10_);
			xmlNodeAddContent (iter, "\n\t");
			_tmp11_ = auth_account_get_active (acc);
			_tmp12_ = bool_to_string (_tmp11_);
			_tmp13_ = _tmp12_;
			xmlNewTextChild (iter, ns, "active", _tmp13_);
			_g_free0 (_tmp13_);
			xmlNodeAddContent (iter, "\n");
			xmlNodeAddContent (root, "\n");
			_g_object_unref0 (acc);
		}
		_g_object_unref0 (_acc_list);
	}
	_tmp14_ = fopen (self->priv->acc_file_path, "w");
	stream = _tmp14_;
	xmlDocDump (stream, xmldoc);
	_fclose0 (stream);
}


AuthAccount* auth_accounts_get_current_account (AuthAccounts* self) {
	AuthAccount* result = NULL;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GeeArrayList* _tmp0_;
		GeeArrayList* _acc_list;
		gint _tmp1_;
		gint _acc_size;
		gint _acc_index;
		_tmp0_ = _g_object_ref0 (self->priv->acc_lst);
		_acc_list = _tmp0_;
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _acc_list);
		_acc_size = _tmp1_;
		_acc_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			AuthAccount* acc;
			gboolean _tmp3_;
			_acc_index = _acc_index + 1;
			if (!(_acc_index < _acc_size)) {
				break;
			}
			_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _acc_list, _acc_index);
			acc = (AuthAccount*) _tmp2_;
			_tmp3_ = auth_account_get_active (acc);
			if (_tmp3_) {
				result = acc;
				_g_object_unref0 (_acc_list);
				return result;
			}
			_g_object_unref0 (acc);
		}
		_g_object_unref0 (_acc_list);
	}
	_tmp4_ = gee_collection_get_size ((GeeCollection*) self->priv->acc_lst);
	if (_tmp4_ > 0) {
		gpointer _tmp5_ = NULL;
		AuthAccount* acc;
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) self->priv->acc_lst, 0);
		acc = (AuthAccount*) _tmp5_;
		auth_account_set_active (acc, TRUE);
		auth_accounts_write (self);
		result = acc;
		return result;
	} else {
		result = NULL;
		return result;
	}
}


void auth_accounts_add_account (AuthAccounts* self, AuthAccount* acc) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (acc != NULL);
	gee_abstract_collection_add ((GeeAbstractCollection*) self->priv->acc_lst, acc);
}


void auth_accounts_delete_account (AuthAccounts* self, const gchar* hash) {
	AuthAccount* _tmp0_ = NULL;
	AuthAccount* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (hash != NULL);
	_tmp0_ = auth_accounts_get_by_hash (self, hash);
	_tmp1_ = _tmp0_;
	gee_abstract_collection_remove ((GeeAbstractCollection*) self->priv->acc_lst, _tmp1_);
	_g_object_unref0 (_tmp1_);
}


void auth_accounts_set_active_account (AuthAccounts* self, const gchar* hash) {
	AuthAccount* _tmp3_ = NULL;
	AuthAccount* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (hash != NULL);
	{
		GeeArrayList* _tmp0_;
		GeeArrayList* _acc_list;
		gint _tmp1_;
		gint _acc_size;
		gint _acc_index;
		_tmp0_ = _g_object_ref0 (self->priv->acc_lst);
		_acc_list = _tmp0_;
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _acc_list);
		_acc_size = _tmp1_;
		_acc_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			AuthAccount* acc;
			_acc_index = _acc_index + 1;
			if (!(_acc_index < _acc_size)) {
				break;
			}
			_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _acc_list, _acc_index);
			acc = (AuthAccount*) _tmp2_;
			auth_account_set_active (acc, FALSE);
			_g_object_unref0 (acc);
		}
		_g_object_unref0 (_acc_list);
	}
	_tmp3_ = auth_accounts_get_by_hash (self, hash);
	_tmp4_ = _tmp3_;
	auth_account_set_active (_tmp4_, TRUE);
	_g_object_unref0 (_tmp4_);
	g_signal_emit_by_name (self, "active-changed");
}


void auth_accounts_change_account (AuthAccounts* self, gint index, AuthAccount* acc) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (acc != NULL);
	gee_abstract_list_set ((GeeAbstractList*) self->priv->acc_lst, index, acc);
}


AuthAccount* auth_accounts_get_by_hash (AuthAccounts* self, const gchar* hash) {
	AuthAccount* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (hash != NULL, NULL);
	{
		GeeArrayList* _tmp0_;
		GeeArrayList* _acc_list;
		gint _tmp1_;
		gint _acc_size;
		gint _acc_index;
		_tmp0_ = _g_object_ref0 (self->priv->acc_lst);
		_acc_list = _tmp0_;
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _acc_list);
		_acc_size = _tmp1_;
		_acc_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			AuthAccount* acc;
			const gchar* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			gchar* _tmp6_;
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gboolean _tmp10_;
			_acc_index = _acc_index + 1;
			if (!(_acc_index < _acc_size)) {
				break;
			}
			_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _acc_list, _acc_index);
			acc = (AuthAccount*) _tmp2_;
			_tmp3_ = auth_account_get_login (acc);
			_tmp4_ = auth_account_get_service (acc);
			_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
			_tmp6_ = _tmp5_;
			_tmp7_ = auth_account_get_proxy (acc);
			_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_strcmp0 (_tmp9_, hash) == 0;
			_g_free0 (_tmp9_);
			_g_free0 (_tmp6_);
			if (_tmp10_) {
				result = acc;
				_g_object_unref0 (_acc_list);
				return result;
			}
			_g_object_unref0 (acc);
		}
		_g_object_unref0 (_acc_list);
	}
	result = NULL;
	return result;
}


GeeArrayList* auth_accounts_get_accounts (AuthAccounts* self) {
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->acc_lst;
	return result;
}


static void auth_accounts_class_init (AuthAccountsClass * klass) {
	auth_accounts_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AuthAccountsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_auth_accounts_get_property;
	G_OBJECT_CLASS (klass)->finalize = auth_accounts_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), AUTH_ACCOUNTS_ACCOUNTS, g_param_spec_object ("accounts", "accounts", "accounts", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("changed", AUTH_TYPE_ACCOUNTS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("active_changed", AUTH_TYPE_ACCOUNTS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void auth_accounts_instance_init (AuthAccounts * self) {
	self->priv = AUTH_ACCOUNTS_GET_PRIVATE (self);
}


static void auth_accounts_finalize (GObject* obj) {
	AuthAccounts * self;
	self = AUTH_ACCOUNTS (obj);
	_g_object_unref0 (self->priv->acc_lst);
	_g_free0 (self->priv->acc_file_path);
	G_OBJECT_CLASS (auth_accounts_parent_class)->finalize (obj);
}


GType auth_accounts_get_type (void) {
	static volatile gsize auth_accounts_type_id__volatile = 0;
	if (g_once_init_enter (&auth_accounts_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AuthAccountsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) auth_accounts_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AuthAccounts), 0, (GInstanceInitFunc) auth_accounts_instance_init, NULL };
		GType auth_accounts_type_id;
		auth_accounts_type_id = g_type_register_static (G_TYPE_OBJECT, "AuthAccounts", &g_define_type_info, 0);
		g_once_init_leave (&auth_accounts_type_id__volatile, auth_accounts_type_id);
	}
	return auth_accounts_type_id__volatile;
}


static void _vala_auth_accounts_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AuthAccounts * self;
	self = AUTH_ACCOUNTS (object);
	switch (property_id) {
		case AUTH_ACCOUNTS_ACCOUNTS:
		g_value_set_object (value, auth_accounts_get_accounts (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



