/* web_url.c generated by valac 0.12.0, the Vala compiler
 * generated from web_url.vala, do not modify */

/* web_url.vala
 *
 * Copyright (C) 2010 Kushal Das <kushal@fedoraproject.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>

#define _soup_buffer_free0(var) ((var == NULL) ? NULL : (var = (soup_buffer_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gchar* get_html_url (const gchar* url);
gchar* get_lekhonee_template (const gchar* url, const gchar* ntitle, const gchar* ncontent);


gchar* get_html_url (const gchar* url) {
	gchar* result = NULL;
	SoupSessionAsync* _tmp0_ = NULL;
	SoupSessionAsync* session;
	SoupMessage* _tmp1_ = NULL;
	SoupMessage* message;
	SoupBuffer* _tmp2_ = NULL;
	SoupBuffer* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = (SoupSessionAsync*) soup_session_async_new ();
	session = _tmp0_;
	_tmp1_ = soup_message_new ("GET", url);
	message = _tmp1_;
	soup_session_send_message ((SoupSession*) session, message);
	_tmp2_ = soup_message_body_flatten (message->response_body);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup ((const gchar*) _tmp3_->data);
	_tmp5_ = _tmp4_;
	_soup_buffer_free0 (_tmp3_);
	result = _tmp5_;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GRegex* _tmp2_ = NULL;
	GRegex* _tmp3_;
	GRegex* regex;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_tmp0_ = g_regex_escape_string (old, -1);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	regex = _tmp3_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch1_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (regex);
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch1_g_regex_error;
		}
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp5_;
	_g_regex_unref0 (regex);
	return result;
	_g_regex_unref0 (regex);
	goto __finally1;
	__catch1_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* get_lekhonee_template (const gchar* url, const gchar* ntitle, const gchar* ncontent) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* oldpost;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (url != NULL, NULL);
	g_return_val_if_fail (ntitle != NULL, NULL);
	g_return_val_if_fail (ncontent != NULL, NULL);
	_tmp0_ = get_html_url (url);
	oldpost = _tmp0_;
	_tmp1_ = string_replace (oldpost, "OLDTITLE", ntitle);
	_g_free0 (oldpost);
	oldpost = _tmp1_;
	_tmp2_ = string_replace (oldpost, "TESTDESC", ncontent);
	_g_free0 (oldpost);
	oldpost = _tmp2_;
	result = oldpost;
	return result;
}



